//
//  kd_tree.h̃Tv
//
#include <stdio.h>
#include <limits.h>
#include <time.h>
#include "../min_pq.h"
#include "../kd_tree.h"


int main()
{
	int num, dim;
	int t0;

	// ̗vfƎ
	num = 50000;
	dim = 128;

	// vf̃[N蓖
	fpoint_t   *nodes;
	nodes = new fpoint_t[num];	

	// vfKɐݒ
	srand(0);
	int i, j;
	for(i = 0;i < num;i++)
	{
		for(j = 0;j < dim;j++)
		{
			nodes[i].x[j] = rand()% 10000 / 10000.0;
		};// j
	};// i

	// kd؂̍\zBkd؂̗vf͓Kɑ߂ɊmۂĂB
	int kd_node_num = num * 2;
	kd_node_t *kd_nodes;
	kd_nodes = new kd_node_t[kd_node_num];	
	printf("build kd-tree...");
	kdtree_build(0, num, dim, kd_nodes, nodes);
	printf("done\n");

	fpoint_t node;
	min_pq  minpq;

	// Ts
	int it, max_it;
	int best_idx;
	int w, h;
	w = h = 256;
	max_it = w * h;
	printf("iteration=%d, pts_num=%d, dim=%d\nNN-search...", max_it, num, dim);
	t0 = clock();
	int c = 0;
	for(it = 0;it < max_it;it++)
	{
		// TL[Kɍ쐬
		for(j = 0;j < dim;j++)
		{
			node.x[j] = nodes[it%w].x[j];
		};
		minpq.n = 0;
		best_idx = kd_tree_search(&kd_nodes[0], &node, dim, 100, &minpq, kd_nodes, nodes);
		// vZʂCfbNXԂ`FbN
		if(best_idx != it%w)
			c++;
	};
	printf("done\nCPU time = %d[msec]\n", clock() - t0);
	printf("fail num=%d\n", c);

	return 0;
};
