//*********************************************************************************
// Best Bin First Kd-tree ċAgȂ\̓ɍċAIȃ|C^Ȃo[W 
//                                                       by G.Koutaki 2012/07/01
//
// {IɂRob HessSIFTCukd_treemin_pqύX̂łB
// Rob Hess : http://blogs.oregonstate.edu/hess
//
// kd؂̍\zɂ͍ċAgAŋߖTT[`ƗDL[͍ċAgȂB
// 
//*********************************************************************************

// IWi̓fBAô߃\[g܂ŏĂSTLg
#include <algorithm>

//*********************************************************************************
// _̃f[^\
//*********************************************************************************
struct fpoint_t 
{
	float x[256];
};

//*********************************************************************************
// kd؂̃m[h\
//*********************************************************************************
struct kd_node_t
{
	unsigned char ki;           // (256܂)
	float         kv;           // lił̓fBAj
	char   leaf;                // tm[hۂ
	unsigned short n;           // tm[hɊ܂܂vfîƂ01ɂĂj
	// ȉ̓IWił̓|C^ACfbNX`ɕύX
	int pts;					// tm[h̃CfbNX
	int kd_left;			    // kd؃m[hւ̃CfbNX
	int kd_right;				// Ekd؃m[hւ̃CfbNX
};


//kd؍\z

//*********************************************************************************
// |C^^mallocgȂ߁A\ߑ߂̔zmۂĂA 
// ȉ̃CfbNXϐŊǗB
int kd_malloc_idx = 0;

//*********************************************************************************
// kd؂̗vfVɊ蓖āBg
//*********************************************************************************
int kd_node_init(int pts, int n ,kd_node_t *node_data, fpoint_t * pts_data)
{
	kd_node_t * kd_node = &node_data[kd_malloc_idx++];

	memset( kd_node, 0, sizeof( kd_node_t ) );
	kd_node->ki = -1;
	kd_node->kd_left  = -1;
	kd_node->kd_right = -1;
	kd_node->pts = pts;
	kd_node->n = n;

	return kd_malloc_idx - 1;
};

//*********************************************************************************
// IŁÃfBAvZ
//*********************************************************************************
void assign_part_key( int kd_node_idx, int dim, kd_node_t *node_data, fpoint_t * pts_data)
{
	fpoint_t  * pts;
	kd_node_t * kd_node = &node_data[kd_node_idx];

	float kv, x, mean, var, var_max = 0;
	float *tmp;
	int d, n, i, j, ki = 0;

	pts = &pts_data[kd_node->pts];
	n = kd_node->n;
	d = dim;

	// Uԑ傫ȎI
	for( j = 0; j < d; j++ )
	{
		// ɕρAUvZ
		mean = var = 0;
		for( i = 0; i < n; i++ )
			mean += pts[i].x[j];
		mean /= n;
		for( i = 0; i < n; i++ )
		{
			x = pts[i].x[j] - mean;
			var += x * x;
		}
		var /= n;
		// ő啪U
		if( var > var_max )
		{
			ki = j;
			var_max = var;
		}
	}

	// őI񂾎̗vfl݂̂Ń\[gB̂߁AxAzm
	tmp = (float*)calloc( n, sizeof( float ) );
	for( i = 0; i < n; i++ )
		tmp[i] = pts_data[kd_node->pts + i].x[ki];
	// stlŃ\[gIiIWi͎Õ\[g[`gĂj
	std::sort(&tmp[0], &tmp[n]);
	// l擾
	kv = tmp[n / 2];
	// [N
	free( tmp );
	// kiƕlkvݒ
	kd_node->ki = ki;
	kd_node->kv = kv;
}

//*********************************************************************************
// ki̕lkvɏ]āA_ptsAkd؂ƉEkd؂ɐU蕪
//*********************************************************************************
void partition_pts( kd_node_t * kd_node , kd_node_t *node_data, fpoint_t * pts_data)
{
	fpoint_t * pts, tmp;
	double kv;
	int n, ki, p, i, j = -1;

	pts = &pts_data[kd_node->pts];
	n   = kd_node->n;
	ki  = kd_node->ki;
	kv  = kd_node->kv;
	// S_Ekd؂ɐU蕪
	for( i = 0; i < n; i++ )
	{
		if( pts[i].x[ki] <= kv )
		{
			tmp = pts[++j];
			pts[j] = pts[i];
			pts[i] = tmp;
			if( pts[j].x[ki] == kv )
				p = j;
		}
	};
	tmp = pts[p];
	pts[p] = pts[j];
	pts[j] = tmp;

	/* if all records fall on same side of partition, make node a leaf */
	if( j == n - 1 )
	{
		kd_node->leaf = 1;
		return;
	}

	// Ekd؂쐬āAU蕪_蓖Ă
	kd_node->kd_left  = kd_node_init( kd_node->pts,    j + 1 , node_data, pts_data);
	kd_node->kd_right = kd_node_init( kd_node->pts + ( j + 1 ), ( n - j - 1 ), node_data, pts_data);
}

//*********************************************************************************
// ċAIkd؂Ă
// kd؂镪́AċAgĂ悢ƂɂB
//*********************************************************************************
void expand_kd_node_subtree(int kd_node_idx, int dim, kd_node_t *node_data, fpoint_t * pts_data)
{
	kd_node_t * kd_node = &node_data[kd_node_idx];

	// vfPȉȂ΁Atm[hƂB
	// 1ȏɂ΁Atm[hɕ_܂܂邱Ƃ\
	if( kd_node->n <= 1 )
	{
		kd_node->leaf = 1;
		return;
	}

	// IŁA_ptsU蕪
	assign_part_key( kd_node_idx, dim, node_data, pts_data);
	partition_pts(   kd_node         , node_data, pts_data);

	// ċAIɕ
	if( kd_node->kd_left >= 0)
		expand_kd_node_subtree( kd_node->kd_left, dim, node_data, pts_data);
	if( kd_node->kd_right>= 0)
		expand_kd_node_subtree( kd_node->kd_right,dim, node_data, pts_data);
}

//*****************************************************************************************
//   kd؍\z̍ŏʃ[`
//*****************************************************************************************
int kdtree_build( int pts, int n, int dim, kd_node_t *node_data, fpoint_t * pts_data)
{
	int kd_root;

	kd_root = kd_node_init(pts, n, node_data, pts_data);
	expand_kd_node_subtree(kd_root, dim, node_data, pts_data);

	return kd_root;
};

//kd؍\zi܂Łj




//kd؂ɂŋߖTTij




//*****************************************************************************************
//   Q_Ԃ̃[Nbh̓vZ
//*****************************************************************************************
float distance(fpoint_t * pt1, fpoint_t * pt2, int dim)
{
	float ret = 0.0;
	for(int i = 0;i < dim;i++)
		ret += (pt1->x[i]-pt2->x[i])*(pt1->x[i]-pt2->x[i]);

	return ret;
};

//*****************************************************************************************
//   tm[h܂ŒHĂ(ċAI)
//*****************************************************************************************
kd_node_t * explore_to_leaf(
	kd_node_t* kd_node, 
	fpoint_t * pts,
	min_pq* min_pq,
	kd_node_t *node_data, 
	fpoint_t  *pts_data
	)
{
	kd_node_t * unexpl, * expl = kd_node;
	double kv;
	int ki;

	while( expl  &&  ! expl->leaf )
	{
		ki = expl->ki;
		kv = expl->kv;

		float off = pts->x[ki] - kv;
		// m[hǂ
		if( off <= 0 )
		{
			unexpl = &node_data[expl->kd_right];
			expl   = &node_data[expl->kd_left];
		}
		else
		// Em[hǂ
		{
			unexpl = &node_data[expl->kd_left];
			expl   = &node_data[expl->kd_right];
		}

		// HȂm[h͌ŒĤŁADL[Ɋi[
		minpq_insert( min_pq, unexpl, off * off );
	}

	return expl;
}

//*****************************************************************************************
//   ŋߖTTC[`(ċAI)
//*****************************************************************************************
int kd_tree_search( 
	kd_node_t * kd_root, 
	fpoint_t  * in,
	int dim,
	int max_nn_chks, 
	min_pq* min_pq,
	kd_node_t *node_data, 
	fpoint_t  *pts_data
	)
{
	kd_node_t * expl;
	int  best_pt;
	float best_dist = 9999999;
	int i, t = 0, n = 0;

	// [gDL[ɒǉ
	minpq_insert( min_pq, kd_root, 0 );
	// L[ɗvfAL[o񐔂w񐔈ȉȂΈȉs
	while( min_pq->n > 0  &&  t < max_nn_chks )
	{
		// DL[vfo
		expl = (kd_node_t*)minpq_extract_min( min_pq );
		// tm[h܂ŒH
		expl = explore_to_leaf( expl, in, min_pq, node_data, pts_data);
		// tm[h̗vfŋߖTۂ`FbN
		for( i = 0; i < expl->n; i++ )
		{
			float dist = distance(in, &pts_data[expl->pts + i], dim);
			if(dist < best_dist)
			{
				best_dist = dist;
				best_pt   = expl->pts + i;
			};
		}
		t++;
	}
	// ŋߖTƎvvf̃CfbNXԂ
	return best_pt;
}


